/*
 * Hypercube API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.2.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package it.nextworks.nfvmano.sbi.starfish.api;

import it.nextworks.nfvmano.sbi.starfish.ApiCallback;
import it.nextworks.nfvmano.sbi.starfish.ApiClient;
import it.nextworks.nfvmano.sbi.starfish.ApiException;
import it.nextworks.nfvmano.sbi.starfish.ApiResponse;
import it.nextworks.nfvmano.sbi.starfish.Configuration;
import it.nextworks.nfvmano.sbi.starfish.Pair;
import it.nextworks.nfvmano.sbi.starfish.ProgressRequestBody;
import it.nextworks.nfvmano.sbi.starfish.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import it.nextworks.nfvmano.sbi.starfish.model.Details;
import it.nextworks.nfvmano.sbi.starfish.model.Kpis;
import it.nextworks.nfvmano.sbi.starfish.model.TrafficCounters;
import it.nextworks.nfvmano.sbi.starfish.model.TrafficFormats;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class NetworkSlicesApi {
    private ApiClient apiClient;

    public NetworkSlicesApi() {
        this(Configuration.getDefaultApiClient());
    }

    public NetworkSlicesApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for migrateNetworkSliceNetworksliceMigratePut
     * @param sliceUid  (required)
     * @param gatewayName  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call migrateNetworkSliceNetworksliceMigratePutCall(String sliceUid, String gatewayName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/networkslice/migrate";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (sliceUid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("slice_uid", sliceUid));
        if (gatewayName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("gateway_name", gatewayName));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "OAuth2PasswordBearer" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call migrateNetworkSliceNetworksliceMigratePutValidateBeforeCall(String sliceUid, String gatewayName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'sliceUid' is set
        if (sliceUid == null) {
            throw new ApiException("Missing the required parameter 'sliceUid' when calling migrateNetworkSliceNetworksliceMigratePut(Async)");
        }
        // verify the required parameter 'gatewayName' is set
        if (gatewayName == null) {
            throw new ApiException("Missing the required parameter 'gatewayName' when calling migrateNetworkSliceNetworksliceMigratePut(Async)");
        }
        
        com.squareup.okhttp.Call call = migrateNetworkSliceNetworksliceMigratePutCall(sliceUid, gatewayName, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Migrate Network Slice
     * 
     * @param sliceUid  (required)
     * @param gatewayName  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void migrateNetworkSliceNetworksliceMigratePut(String sliceUid, String gatewayName) throws ApiException {
        migrateNetworkSliceNetworksliceMigratePutWithHttpInfo(sliceUid, gatewayName);
    }

    /**
     * Migrate Network Slice
     * 
     * @param sliceUid  (required)
     * @param gatewayName  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> migrateNetworkSliceNetworksliceMigratePutWithHttpInfo(String sliceUid, String gatewayName) throws ApiException {
        com.squareup.okhttp.Call call = migrateNetworkSliceNetworksliceMigratePutValidateBeforeCall(sliceUid, gatewayName, null, null);
        return apiClient.execute(call);
    }

    /**
     * Migrate Network Slice (asynchronously)
     * 
     * @param sliceUid  (required)
     * @param gatewayName  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call migrateNetworkSliceNetworksliceMigratePutAsync(String sliceUid, String gatewayName, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = migrateNetworkSliceNetworksliceMigratePutValidateBeforeCall(sliceUid, gatewayName, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for networksliceDetailsNetworksliceDetailsGet
     * @param sliceUid  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call networksliceDetailsNetworksliceDetailsGetCall(String sliceUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/networkslice/details";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (sliceUid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("slice_uid", sliceUid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "OAuth2PasswordBearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call networksliceDetailsNetworksliceDetailsGetValidateBeforeCall(String sliceUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'sliceUid' is set
        if (sliceUid == null) {
            throw new ApiException("Missing the required parameter 'sliceUid' when calling networksliceDetailsNetworksliceDetailsGet(Async)");
        }
        
        com.squareup.okhttp.Call call = networksliceDetailsNetworksliceDetailsGetCall(sliceUid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Networkslice Details
     * 
     * @param sliceUid  (required)
     * @return Details
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Details networksliceDetailsNetworksliceDetailsGet(String sliceUid) throws ApiException {
        ApiResponse<Details> resp = networksliceDetailsNetworksliceDetailsGetWithHttpInfo(sliceUid);
        return resp.getData();
    }

    /**
     * Networkslice Details
     * 
     * @param sliceUid  (required)
     * @return ApiResponse&lt;Details&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Details> networksliceDetailsNetworksliceDetailsGetWithHttpInfo(String sliceUid) throws ApiException {
        com.squareup.okhttp.Call call = networksliceDetailsNetworksliceDetailsGetValidateBeforeCall(sliceUid, null, null);
        Type localVarReturnType = new TypeToken<Details>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Networkslice Details (asynchronously)
     * 
     * @param sliceUid  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call networksliceDetailsNetworksliceDetailsGetAsync(String sliceUid, final ApiCallback<Details> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = networksliceDetailsNetworksliceDetailsGetValidateBeforeCall(sliceUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Details>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for networksliceKpisNetworksliceKpisGet
     * @param sliceUid  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call networksliceKpisNetworksliceKpisGetCall(String sliceUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/networkslice/kpis";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (sliceUid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("slice_uid", sliceUid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "OAuth2PasswordBearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call networksliceKpisNetworksliceKpisGetValidateBeforeCall(String sliceUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'sliceUid' is set
        if (sliceUid == null) {
            throw new ApiException("Missing the required parameter 'sliceUid' when calling networksliceKpisNetworksliceKpisGet(Async)");
        }
        
        com.squareup.okhttp.Call call = networksliceKpisNetworksliceKpisGetCall(sliceUid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Networkslice Kpis
     * 
     * @param sliceUid  (required)
     * @return Kpis
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Kpis networksliceKpisNetworksliceKpisGet(String sliceUid) throws ApiException {
        ApiResponse<Kpis> resp = networksliceKpisNetworksliceKpisGetWithHttpInfo(sliceUid);
        return resp.getData();
    }

    /**
     * Networkslice Kpis
     * 
     * @param sliceUid  (required)
     * @return ApiResponse&lt;Kpis&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Kpis> networksliceKpisNetworksliceKpisGetWithHttpInfo(String sliceUid) throws ApiException {
        com.squareup.okhttp.Call call = networksliceKpisNetworksliceKpisGetValidateBeforeCall(sliceUid, null, null);
        Type localVarReturnType = new TypeToken<Kpis>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Networkslice Kpis (asynchronously)
     * 
     * @param sliceUid  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call networksliceKpisNetworksliceKpisGetAsync(String sliceUid, final ApiCallback<Kpis> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = networksliceKpisNetworksliceKpisGetValidateBeforeCall(sliceUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Kpis>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for networksliceTrafficCountersNetworksliceTrafficCountersGet
     * @param sliceUid  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call networksliceTrafficCountersNetworksliceTrafficCountersGetCall(String sliceUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/networkslice/traffic_counters";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (sliceUid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("slice_uid", sliceUid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "OAuth2PasswordBearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call networksliceTrafficCountersNetworksliceTrafficCountersGetValidateBeforeCall(String sliceUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'sliceUid' is set
        if (sliceUid == null) {
            throw new ApiException("Missing the required parameter 'sliceUid' when calling networksliceTrafficCountersNetworksliceTrafficCountersGet(Async)");
        }
        
        com.squareup.okhttp.Call call = networksliceTrafficCountersNetworksliceTrafficCountersGetCall(sliceUid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Networkslice Traffic Counters
     * 
     * @param sliceUid  (required)
     * @return TrafficCounters
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TrafficCounters networksliceTrafficCountersNetworksliceTrafficCountersGet(String sliceUid) throws ApiException {
        ApiResponse<TrafficCounters> resp = networksliceTrafficCountersNetworksliceTrafficCountersGetWithHttpInfo(sliceUid);
        return resp.getData();
    }

    /**
     * Networkslice Traffic Counters
     * 
     * @param sliceUid  (required)
     * @return ApiResponse&lt;TrafficCounters&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TrafficCounters> networksliceTrafficCountersNetworksliceTrafficCountersGetWithHttpInfo(String sliceUid) throws ApiException {
        com.squareup.okhttp.Call call = networksliceTrafficCountersNetworksliceTrafficCountersGetValidateBeforeCall(sliceUid, null, null);
        Type localVarReturnType = new TypeToken<TrafficCounters>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Networkslice Traffic Counters (asynchronously)
     * 
     * @param sliceUid  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call networksliceTrafficCountersNetworksliceTrafficCountersGetAsync(String sliceUid, final ApiCallback<TrafficCounters> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = networksliceTrafficCountersNetworksliceTrafficCountersGetValidateBeforeCall(sliceUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TrafficCounters>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for networksliceTrafficFormatsNetworksliceTrafficFormatsGet
     * @param sliceUid  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call networksliceTrafficFormatsNetworksliceTrafficFormatsGetCall(String sliceUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/networkslice/traffic_formats";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (sliceUid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("slice_uid", sliceUid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "OAuth2PasswordBearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call networksliceTrafficFormatsNetworksliceTrafficFormatsGetValidateBeforeCall(String sliceUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'sliceUid' is set
        if (sliceUid == null) {
            throw new ApiException("Missing the required parameter 'sliceUid' when calling networksliceTrafficFormatsNetworksliceTrafficFormatsGet(Async)");
        }
        
        com.squareup.okhttp.Call call = networksliceTrafficFormatsNetworksliceTrafficFormatsGetCall(sliceUid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Networkslice Traffic Formats
     * 
     * @param sliceUid  (required)
     * @return List&lt;TrafficFormats&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<TrafficFormats> networksliceTrafficFormatsNetworksliceTrafficFormatsGet(String sliceUid) throws ApiException {
        ApiResponse<List<TrafficFormats>> resp = networksliceTrafficFormatsNetworksliceTrafficFormatsGetWithHttpInfo(sliceUid);
        return resp.getData();
    }

    /**
     * Networkslice Traffic Formats
     * 
     * @param sliceUid  (required)
     * @return ApiResponse&lt;List&lt;TrafficFormats&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<TrafficFormats>> networksliceTrafficFormatsNetworksliceTrafficFormatsGetWithHttpInfo(String sliceUid) throws ApiException {
        com.squareup.okhttp.Call call = networksliceTrafficFormatsNetworksliceTrafficFormatsGetValidateBeforeCall(sliceUid, null, null);
        Type localVarReturnType = new TypeToken<List<TrafficFormats>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Networkslice Traffic Formats (asynchronously)
     * 
     * @param sliceUid  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call networksliceTrafficFormatsNetworksliceTrafficFormatsGetAsync(String sliceUid, final ApiCallback<List<TrafficFormats>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = networksliceTrafficFormatsNetworksliceTrafficFormatsGetValidateBeforeCall(sliceUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<TrafficFormats>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
